/*验证规则*/
var FORM_VERIFY_RULE={
    "mobile":[
        {
            reg:/\S+/,
            error:"手机号不能为空"
        },
        {
            reg:/^\d{6,}$/,
            error:"请输入正确的手机号"
        }
    ],
    "password":[
        {
            reg:/\S+/,
            error:"密码不能为空"
        },
        {
            reg:/^.{6,}$/,
            error:"密码格式错误"
        }
    ],
    "passwordAgain":[
        {
            reg:function(v,o,f){
                return v===o["password"];
            },
            error:"两次输入的密码不一致"
        }
    ],
    "verifyCode":[
        {
            reg:/\S+/,
            error:"验证码不能为空"
        },
        {
            reg:/^.{4,}$/,
            error:"验证码格式错误"
        }
    ],
    "passwordRegister":[
        {
            reg:/\S+/,
            error:"密码不能为空"
        },
        {
            reg:/^.{6,}$/,
            error:"密码不能少于6位"
        }
    ]
};
/*验证码发送间隔*/
var VERIFY_SEND_TIMEOUT=60;

//验证、获取form内的数据
function getFormData(q,single){
    var form=q;
    var o={},er=false;
    if(!single){
        form=form.find("input,select,textarea");
    }
    var formVerifyRule=FORM_VERIFY_RULE;
    form.each(function(i){
        if(er){
            return false;
        }
        var _t=$(this);
        var _n=_t.attr("name");
        var _v=_t.val().replace(/(^\s*)|(\s*$)/g,"");
        var _ver=_t.data("verify");
        if(_n){
            o[_n]=_v;
            if(_ver&&formVerifyRule[_ver]){
                for(var j=0;j<formVerifyRule[_ver].length;j++){
                    if(app.dataType(formVerifyRule[_ver][j].reg)=="RegExp"){
                        if(!formVerifyRule[_ver][j].reg.test(_v)){
                            er=formVerifyRule[_ver][j].error;
                            return false;
                        }
                    }
                    else if(app.dataType(formVerifyRule[_ver][j].reg)=="Function"){
                        if(!formVerifyRule[_ver][j].reg(_v,o,form)){
                            er=formVerifyRule[_ver][j].error;
                            return false;
                        }
                    }
                }
            }
        }
    });
    er&&app.toast(er);
    return er?null:o;
}

//发送验证码 (按钮节点，获取方式。接口附加传参)
function getCode(id,type,data){
    var _t=typeof id=="string"?$("#"+id):id;
    var saveText=_t.text();
    var urls={
        // "emailRegister":{url:"/index.php?act=login&op=send_email"},
        "mobileRegister":{url:"/index.php?act=login&op=send_verify_reg"},
        // "emailForget":{url:"/index.php?act=login&op=send_email"},
        "mobileForget":{url:"/index.php?act=login&op=send_verify_pas"}
    };
    var count=VERIFY_SEND_TIMEOUT;
    if(_t.hasClass("dis")){
        return false;
    }
    if(!urls[type]){
        throw Error("没有找到发送"+type+"验证码方式")
    }
    //发送请求
    _t.addClass("dis");
    app.post({
        url:app.config.url+urls[type].url,
        data:typeof data==="object"?data:{},
        success:function(res){
            _t.text(count+"秒后重试");
            app.interval(function(i){
                _t.text(count-i+"秒后重试");
            },1000,count,function(){
                _t.text(saveText).removeClass("dis");
            });
        },
        defeat:function(e){
            app.toast(e.msg);
            _t.text(saveText).removeClass("dis");
        }
    });
}