app.ready(function(){
    if(app.userIdentity()==="y"){
        //游客关闭个推
        return false
    }

    /*
     * 处理个推功能
     * ps:个推和客服有冲突，部分客服推送处理（本地通知）在个推中进行监听处理
     * */
    (function(){
        var RG_TIME=1;//绑定设备失败后重试次数
        var MAX_LX_TIME=4;//判断启动后几秒内收到消息为离线推送
        var MAX_HT_TIME=2;//判断应用切换到前台时，几秒内收到消息为在线推送

        var cachePayloadMsg=null;//缓存两次推送消息
        var isFirst=true;//初始化一次
        var payLoadCallBack=null;//延时处理点击推送跳转

        var cid,GTMd;
        // setTimeout(function(){
        //     app.toast("init");
            initGT();
        // },6000);

        /*
         * 设备id和用户绑定，避免推送到多个终端
         * callback:绑定成功
         * */
        function registerDevice(callback){
            if(cid){
                var appos=app.isIos?2:1;//设备类型
                app.post({
                    url: app.config.url + "/index.php?act=push&op=get_cid",
                    data: {
                        "cid": cid,
                        "appos": appos,
                    },
                    success:function(r){
                        //绑定成功一次后，后续的绑定操作无视（ios bug）
                        isFirst&&typeof callback==="function"&&callback();
                        isFirst=false;
                    },
                    defeat:function(data){
                        if(RG_TIME>0){
                            registerDevice();
                        }
                        RG_TIME--;
                    }
                }, true);
            }
        }

        /*
         * 获取app目前状态，用于分情况处理推送来的消息
         * 返回值：{type:1}
         * ps:type:1 应用刚启动不足n秒（类似于离线推送）//改为个推刚初始化不足n秒
         *         2 应用正在前台运行
         *         3 应用刚从后台返回前台
         * */
        function getRunStatus(){
            var status={};
            var nd=new Date().getTime();
            var gtAppOpenStg=app.getStorage("gtLoadingTime");
            var gtAppResumeStg=app.getStorage("gtAppResume");
            if(gtAppOpenStg&&(nd-gtAppOpenStg)<MAX_LX_TIME*1000){
                status.type=1;
            }
            else if(gtAppResumeStg&&(nd-gtAppResumeStg)<MAX_HT_TIME*1000){
                status.type=3;
            }
            else {
                status.type=2;
            }
            return status;
        }

        /*
         * 根据参数跳转到目标页面
         * param： r 推送给app的字符串
         * */
        function goMsg(r){
            var param = app.toJson(r);
            if(param&&param.msgId){
                var  msgId = param.msgId;
                var  code = param.message_type;
                var  ext = param.extend;
                app.adaptMsg(msgId,code,ext);
            }
            else {
                //...
            }
        }

        /*
         * 初始化个推功能
         *
         *
         * */
        function initGT (){
            GTMd=api.require('pushGeTui');
            GTMd.initialize(function (ret) {
                /*
                * 冲突部分
                * */
                if(ret&&ret["msg"]&&ret["msg"]["key"]&&ret["msg"]["key"]==="新的客服消息"){
                    app.charIm(ret["msg"]["f"],"normal");
                    return false;
                }
                switch (ret.type) {
                    //注册设备id成功,绑定设备和用户
                    case 'cid':
                        //存储注册成功时间
                        if(!app.getStorage("gtLoadingTime")){
                            app.setStorage("gtLoadingTime",new Date().getTime());
                        }
                        cid = ret.cid;
                        registerDevice(function(){
                            //ios绑定token
                            if(app.isIos){
                                GTMd.registerDeviceToken({
                                    deviceToken: api.deviceToken
                                },function(){
                                    // test(arguments);
                                });
                            }
                            else {
                                //安卓处理离线推送
                                GTMd.payloadMessage(function (ret) {
                                    if(ret.result==1){
                                        //由于存在回调两次的bug 判断两次消息体是否相同来决定是否推送这条新消息
                                        if(ret.payload!==cachePayloadMsg){
                                            cachePayloadMsg=ret.payload;
                                            goMsg(ret.payload);
                                        }
                                    }
                                });
                            }
                        });
                        break;
                    //收到推送消息，根据目前app状态分别处理
                    case 'payload':
                        if(payLoadCallBack){
                            clearTimeout(payLoadCallBack);
                        }
                        //由于先执行推送回调再执行resume回调，在300ms后判断
                        payLoadCallBack=setTimeout(function(){
                            var state=getRunStatus();
                            //刚启动应用收到的推送，视为离线推送,立即打开消息内容
                            if(state.type==1){
                                goMsg(ret.payload);
                            }
                            //用户正在使用app，刷新首页消息条数
                            else if(state.type==2){
                                //刷新新消息条数(X了X了)
                                app.fireAll("pushRFCarNum",{});
                                //额外的使用openFloatMsg提醒用户
                                var param=app.toJson(ret.payload);
                                var topCacheWin=app.getStorage("stackCache").topPage;
                                if(param&&param.msgId){
                                    var  title=param["message_title"]||"您收到一条新消息";
                                    var  content=param["message_content"]||"点击查看详情";
                                    var  msgId = param.msgId;
                                    var  code = param.message_type;
                                    var  ext = param.extend;
                                    app.fire({
                                        event:"openFloatMsg",
                                        win:topCacheWin,
                                        param:{title:title,content:content,msg:{
                                            id:msgId,
                                            code:code,
                                            ext:ext
                                        }}
                                    });
                                }
                            }
                            //app在线时点击通知栏，此时打开消息内容
                            else if(state.type==3){
                                goMsg(ret.payload);
                            }
                            /*其他操作*/
                            //刷新消息数量状态
                            app.updateFetch("msgNum");
                        },300);
                        break;
                    case 'occurError':
                        //错误不做任何处理
                        break;
                }
            });
            //应用被唤醒时，作好标记，如果在规定时间内收到了推送消息，被认为是点击消息
            api.addEventListener({
                name:'resume'
            },function(ret,err){
                app.setStorage("gtAppResume",new Date().getTime());
            });
        }
    })();
});