/*
* 预先配置功能
* */
(function(app){
    if(!app){throw Error("没有找到app对象")}
    app.ready(function(){
        /*
         * 初始化状态栏颜色:白底黑字
         * */
        api.setStatusBarStyle({style:app.config.statusBarStyle});
        /*
         * 监听静默修复状态，如果成功，强制重启
         * ps:如果value值为*，此次修复将不会强制重启
         * ps:标题：当前有新的可用更新
         * ps:内容：列出更新项文案
         * ps:操作：请重启
        * */
        app.setStorage("smartUpdateFinishOK",false);
        api.addEventListener({
            name:'smartupdatefinish'
        }, function(ret, err){
            //转移到main.html进行操作，触发方式为改变smartUpdateFinishOK storage
            var v=null;
            //防止ios和安卓APIbug
            if(ret&&ret.value){
                v=ret.value;
            }
            if(ret.value.length&&app.isObj(ret.value[0])&&ret.value[0].extra!==undefined){
                v=ret.value[0].extra;
            }
            v=String(v).replace(/(^\s*)|(\s*$)/g,"");
            if(v!="*"&&v!=""){
                //改变标记的同时触发main页面的smartOK事件，以避免main页面未打开和main页面已打开造成的遗漏
                app.setStorage("smartUpdateFinishOK",{value:v});
                app.fire({
                    event:"smartOK",
                    win:"main",
                    param:{value:v}
                });
                // api.confirm({
                //     title: '当前有新的可用更新',
                //     msg: v,
                //     buttons: ['重启应用', '稍后重启']
                // }, function(ret, err) {
                //     var index = ret.buttonIndex;
                //     if(index==1){
                //         api.rebootApp();
                //     }
                // });
            }
        });
        /*
        * 初始化storage数据
        * ps:减少使用时的判断
        * */
        var initStorageState=function(){
            var initStorageList=app.config.storageConfig,tempStorage;
            app._each(initStorageList.temp,function(i){
                app.setStorage(i,initStorageList.temp[i]);
            });
            app._each(initStorageList.save,function(i){
                tempStorage=app.getStorage(i);
                if(tempStorage===undefined){
                    app.setStorage(i,initStorageList.save[i]);
                }
            });
            //ps:启动时自动转换一次，首次转换后会存储到本地
            var tempPath = null;
            app._each(app.config.pathConfig, function (i) {
                tempPath = this;
                if (i === "root") {
                    app._for(tempPath, function (c) {
                        app.config.pathUrl[tempPath[c]] = api.wgtRootDir + "/html/" + tempPath[c].replace(/[A-Z]/g, function (v) {
                                return "_" + v.toLowerCase();
                            }) + ".html"
                    });
                }
                else {
                    app._for(tempPath, function (c) {
                        app.config.pathUrl[tempPath[c]] = api.wgtRootDir + "/html/" + i + "/" + tempPath[c].replace(/[A-Z]/g, function (v) {
                                return "_" + v.toLowerCase();
                            }) + ".html"
                    });
                }
            });
            app._each(app.config.pathChildConfig, function (i) {
                app._each(this, function (j) {
                    tempPath = this;
                    if (j === "root") {
                        app._for(tempPath, function (c) {
                            app.config.pathUrl[tempPath[c]] = api.wgtRootDir + "/html/child/" + i + "/" + tempPath[c].replace(/[A-Z]/g, function (v) {
                                    return "_" + v.toLowerCase();
                                }) + ".html";
                        });
                    }
                    else {
                        app._for(tempPath, function (c) {
                            app.config.pathUrl[tempPath[c]] = api.wgtRootDir + "/html/child/" + i + "/" + j + "/" + tempPath[c].replace(/[A-Z]/g, function (v) {
                                    return "_" + v.toLowerCase();
                                }) + ".html";
                        });
                    }
                });
            });
            app.setStorage("pathUrl", app.config.pathUrl);
        };
        initStorageState();
        //初始化百度模块
        app.initTj();

        //抛出initStorageState方法给注销使用
        window.initStorageState=initStorageState;

    });
})(window.app);