/*
 * 初始化app对象
 * *配置应用参数、页面路径
 * *初始化页面基本功能
 * */
(function (app) {
    var nowTime = new Date().getTime();
    var parseNowTime = parseInt(nowTime / 1000);
    app.config = {
        //正式地址
        notTest:true,
        fileHost:"https://msul.moyuntv.com",
        host:"https://ygmb2b.com",
        url: "https://api.ygmb2b.com",

        //测试地址
        // fileHost:"https://temsul.moyuntv.com",
        // host: "https://test.ygmb2b.com",
        // url: "https://teapi.ygmb2b.com",

        // 1.88 IP本地地址
        // fileHost: "http://192.168.1.88/shop2/uploadCard",
        // host: "http://192.168.1.88/shop2",
        // url: "http://192.168.1.88/mobileygm",

        //1.90 IP本地地址
        // fileHost: "http://192.168.1.90/shop2/uploadCard",
        // host: "http://192.168.1.90/shop2",
        // url: "http://192.168.1.90/mobileygm",

        //1.66 IP本地地址
        // fileHost: "http://192.168.1.66/shop2/uploadCard",
        // host: "http://192.168.1.66/shop2",
        // url: "http://192.168.1.66/mobileygm",

        //底层页面（底层页面无法返回上一页）
        basePage:["root","main","login","access"],
        //页面路径配置
        pathConfig: {
            "root": ["root", "main","mainHome","mainOrder","mainPublish","mainQuick","mainAgency","mainUser"],//主框架
            "ad": ["ad", "jump"],//广告页
            "common": ["title"],//公用页面
            "guide": ["guide"],//引导页
            "home":["home","homeContent"],//入口页
            "function": ["categoryAlertList", "countryAlertList", "coverHint"],//特殊功能页面
            "login": ["forget", "login", "passAttestation", "passInfo", "protocol", "register", "register1", "register2", "register3"],//登陆注册
            "order": ["order", "orderAfter", "orderAfterInfo", "orderCancel", "orderFillLogistics", "orderInfo", "orderList", "orderLogistics"],//订单页
            "other": ["article", "articleContent", "articleList", "leave", "pay", "paySuccess", "msg", "msgInfo", "ranking"],//其他页面
            "quick": ["quick", "quickList", "quickListContent", "quickMain"],//快捷下单
            "search": ["result", "resultOrder", "resultShopping", "search","searchTag","searchAddr", "searchBrand","searchGlobalShopping","searchOrder","searchPublish","searchShopping", "searchShopping2"],//搜索功能
            "shopping": ["brand", "car", "carList", "class", "classList", "classMenu", "shoppingAffirm", "shoppingInfo", "shoppingInfoAlert", "shoppingInfoContent", "shoppingInfoForCar", "shoppingList"],//商品页
            "tool": ["browser","checkNot", "clip", "floatMsg","imgAlert","leaveMsg","leaveNumber","month", "picture", "pictureMenu", "pictureTop", "select", "white"],//独立功能页面
            "user": ["user","addDomain", "about", "addr", "addrEdit","agency","addTag","attestation", "available", "availableList", "balance", "balanceContent", "bandcardEdit","beAgency","beCoreAgency",
                "changeMobile", "changePassword","inviteCodeList","inviteCodeHistory","releaseTagsEdit","myTagsEdit",
                "orderSum", "orderSum2", "orderSumContent", "orderSumContent2","payAgency","payAgencyAffirm","payAgencySuccess","payInviteSuccess","recommend", "recommendContent", "recommendFilter", "recommendFilterContent", "remain", "remainContent",
                "setting", "shipments", "shipmentsAddr", "shipmentsAddrEdit", "userInfo", "withdraw", "withdrawList", "withdrawStep"],//个人中心
            "temp": [],//临时功能、活动页
            "access":["access","findPassword"],//新入口
        },
        //页面路径配置(子功能)
        pathChildConfig: {
            publish: {
                "root": ["publish"],//主页
                "publish": ["myPublish", "myPublishList", "publishInfo", "publishInfoContent", "publishList", "release"],//发布
                "buy": ["boughtAffirm", "myBought", "myBoughtList"],//购买
                "sell": ["mySell", "mySellList", "quote", "quoteInfo", "quoteList", "sellerOrderInfo", "sellerOrderShipments", "sellerRefund", "sellerRefundAddress", "sellerRefundAffirm", "sellerRefuse"]//报价/售出
            }
        },
        //storage初始化配置
        storageConfig: {
            //每次重启app会被重置
            temp: {
                gtLoadingTime: 0,//应用上次启动时间(个推离线推送伪检测)
                disabledAppLogin: false,//版本是否过低，是否禁止用户登录(检测更新)
                repeatPage: 1,//页面重复堆栈产生的id增量信息(打开新win)
                stackCache: {//页面堆栈缓存(用于获取win层级)
                    topPage: "root",//顶层win的id
                    payBackPage:{
                        win:null,
                        frame:null
                    },//支付返回页面缓存id
                }, 
                fetchData: {},//数据同步缓存(app.registerFetch)
                pathUrl: null,//页面解析缓存(首次启动)
                countryMsg: null,//当前站点国家信息(切换站点)
                countryCache:null,//所有站点国家信息
                refundServer: [],//已经发出过客服介入推送的退款id数组(退款申请介入)
                classInfo: {},//商品分类信息(获取商品分类)
                serverIsInit:false,//客服已初始化成功，可以调用
            },
            //仅在第一次进入应用会被重置
            save: {
                resetUserInfo:"0.0.0",//个人信息已重置的版本
                lastCheckUpdate: 0,//上次检测版本更新时间(app.checkUpdate)
                smartUpdateFinishOK:false,//静默修复完成，临时存储的文字
                lastCheckNotTime:0,//应用上次检查通知是否开启时间(app.checkDevNot)
                checkNotJumpVersion:false,//是否跳过每天一次的通知
                user: {//用户个人信息(进入app时会刷新个人信息，登陆完成时更新个人信息)
                    uid: null,//用户id
                    token: null,//token(没有token字段将会被认为是未登录)
                    username: null,//用户昵称
                    mobile: null,//手机号
                    avatar: null,//头像地址
                    email: null,//邮箱
                    areaInfo: null,//居住地
                    account: null,//是否已进行实名认证
                    reg_step: null,//用户资料完善度 1：刚注册 2：通过邀请验证 3：已完善资料
                    member_qq: null,//QQ信息
                    member_wx: null,//微信信息
                    member_type:null,//角色
                    domain:null,//个人店铺信息
                    inviteNum:null,//个人剩余邀请码
                },
                cacheMobile:null,//缓存上次登录时输入的电话号码
                gtAppResume: 0,//应用上次从后台切换到前台时间(个推通知栏点击伪检测)
                hintCache: {//提示缓存(app.openHint方法)
                    shipments: false,//收货人编辑提示
                    country: false,//首页分站选择提示
                    tag: false//个人中心标签设置提示
                },
                publishMsgStatus: {//发布信息红点更新时间（click代表点击时间，msg代表最新消息时间）(我的-求购)
                    publish: {click: parseNowTime, msg: null},  //我发布的-发布中 最新消息更新时间
                    defeat: {click: parseNowTime, msg: null},  //我发布的-未通过 最新消息更新时间
                    past: {click: parseNowTime, msg: null},  //我发布的-已过期 最新消息更新时间
                    sell: {click: parseNowTime, msg: null}   //我出售的-已售出  最新消息更新时间
                },
                searchCache: {//搜索页历史搜索记录缓存(search)
                    order: [],//搜索订单关键字历史记录
                    shopping: [],//搜索商品关键字历史记录
                    publish:[],//搜索求购关键字历史记录
                },
                quick: {//批量付款订单信息(快捷下单临时缓存的id)
                    orders: []//待批量付款的订单列表
                },
                publishAlertIsOpen:false,//是否切换到求购tab过
                // isReadScanInfo:false,//是否已阅读过身份证扫描功能提示
                cacheRelease:null,//发布求购时缓存的收货地区和发货地要求（release）
                cacheQuote:null,//报价时缓存的收货地区和发货地要求（quote）
                serverNewMsg:false,//是否有客服新消息
                // historyReleaseTags:[],//求购的历史标签缓存
            }
        },
        //解析后路径
        pathUrl: {},
        //公共代理页面
        commonAry: ["title", "result", "search"],//共用头部页面集合,它们的winName为公用name+&+要打开的子页面name+"-"+随机数
        //状态栏默认颜色
        statusBarStyle: "dark",//状态栏：默认黑色
        msg: {
            xfText: "2017-04-17",
            xf: new Date("2017-04-17").getTime()
        },
        //分站国家本地信息（通过code与服务器数据对应）
        country: {
            "all": {
                id: "",
                code: "",
                siteId:0,
                name: "全球",
                img: "/image/country/country-logo-all.png"
            },
            // "0081":{
            //     id:"",
            //     code:"0081",
            //     name:"日本",
            //     img: "/image/country/country-all.jpg"
            // },
            // "0082":{
            //     id:"",
            //     code:"0082",
            //     name:"韩国",
            //     img: "/image/country/country-all.jpg"
            // },
            "0081,0082": {
                id: "",
                code: "0081,0082",
                name: "日韩",
                img: "/image/country/country-logo-0081_0082.png",
            },
            "0033,0049": {
                id: "",
                code: "0033,0049",
                name: "德国",
                img: "/image/country/country-logo-0033_0049.png"
            },
            "0061,0064": {
                id: "",
                code: "0061,0064",
                name: "澳新",
                img: "/image/country/country-logo-0061_0064.png"
            },
            "0061": {
                id: "",
                code: "0061",
                name: "澳大利亚",
                img: "/image/country/country-logo-0061.png"
            },
            "0064": {
                id: "",
                code: "0064",
                name: "新西兰",
                img: "/image/country/country-logo-0064.png"
            },
            "0049": {
                id: "",
                code: "0049",
                name: "德国",
                img: "/image/country/country-logo-0049.png"
            },
            "0033": {
                id: "",
                code: "0033",
                name: "法国",
                img: "/image/country/country-logo-0033.png"
            },
            "001": {
                id: "",
                code: "001",
                name: "美国",
                img: "/image/country/country-logo-001.png"
            }
        },
        floatMsgTimeout:4800,//float内部弹窗关闭延时
    };

    /*
     * 初始化页面功能
     * */
    app.ready(function () {
        //0.适配、兼容性处理
        //适配状态栏(#在有header.hd的情况下自动适配状态栏)
        var hd = document.getElementsByClassName("hd");
        if (!!hd.length) {
            app.fixStatusBar(hd[0]);
            if (hd[0].className.indexOf("hd-fix") !== -1) {
                var cs = getComputedStyle(hd[0]);
                var h = parseInt(cs.height) + parseInt(cs.paddingTop) + parseInt(cs.marginTop) + parseInt(cs.borderTopWidth) + parseInt(cs.borderBottomWidth);
                document.getElementsByTagName("body")[0].style.paddingTop = h + "px";
            }
        }
        //1城市图片路径配置
        app._each(app.config.country, function () {
            this.img = api.wgtRootDir + this.img;
        });
        //2.页面路径配置(将路径属性pathConfig转化为索引对象pathUrl)
        var pathUrl = app.getStorage("pathUrl");
        if (pathUrl) {
            app.config.pathUrl = pathUrl;
        }
        //3.返回键设置 #除了主页面和main，login其他页面都是执行goBack操作来关闭页面
        if (app.inArray(api.winName,app.config.basePage)) {
            //原来为双击退出
            // var keyBackMack = 0;
            // api.addEventListener({name: "keyback"}, function () {
            //     if (new Date().getTime() - keyBackMack < 2000) {
            //         api.closeWidget({silent: true});
            //         return false;
            //     }
            //     keyBackMack = new Date().getTime();
            //     api.toast({
            //         msg: '再次点击退出程序',
            //         duration: "2500"
            //     });
            // });
            //现在改为单击退出到后台
            api.addEventListener({name: "keyback"}, function () {
                api.toLauncher();
            });
        }
        else {
            api.addEventListener({name: "keyback"}, function () {
                app.goBack();
            });
        }
        //4.页面元素事件预先绑定
        app.setGo();
        //5.功能
        //执行提前触发的页面fire（在页面app.ready中绑定事件之前触发，那么会收集在ready之后一起触发，避免创建页面后无法掌握fire调用时机）
        if (app.isArray(window.appTriggerCache)) {
            var ary = window.appTriggerCache;
            app.fireReady = function () {
                app._for(ary, function (i) {
                    if (app.listen.events[ary[i][0]] !== undefined) {
                        app.trigger(ary[i][0], ary[i][1]);
                    }
                });
                window.appTriggerCache = undefined;
            }
        }
        //上面的提前fire在ios下有问题，打开窗口100ms内没有window对象，所以使用pageParam的_initFire参数来执行这些提前的fire(以后调整)
        if (api.pageParam._initFire && api.pageParam._initFire.length) {
            app.fireReady = function () {
                app._for(api.pageParam._initFire, function (i) {
                    !api.pageParam._initFire[i].win&&(api.pageParam._initFire[i].win=api.winName);//没有传入win代表在本窗口环境下
                    app.fire(api.pageParam._initFire[i])
                });
            };
        }
        //6.框架传参、堆栈功能初始化
        //监听数据跨页面刷新
        app.listenAll("fetchDataChange-"+api.winName,function(ret){
            var param=ret.value||{};
            app._localFetchCall[param.type]&&app._localFetchCall[param.type](param.data);
        });
        if(app.isWin()){
            //窗口切换时,检测跨页面数据是否同步
            app.listenExpose(function(){
                //检测本页面是否应该刷新
                setTimeout(function(){
                    app.examineFetchHandle();
                },360);//连续返回时避免此操作
                //缓存本页面id为顶层页面
                if(!api.frameName){
                    var stackCacheStg=app.getStorage("stackCache");
                    stackCacheStg.topPage=api.winName;
                    app.setStorage("stackCache",stackCacheStg);
                }
            });
            //为本页面listen openFloatMsg 事件，用于顶层win弹窗
            app.listen("openFloatMsg",function(p){
                app.openFloatMsg(p.title,p.content,function(){
                    if(p.msg){
                        //消息
                        app.adaptMsg(p.msg.id,p.msg.code,p.msg.ext);
                    }
                    else if(p.im){
                        //客服
                        app.charIm(p.im,"normal");
                    }
                });
            });
            //退出到后台关闭客服窗口
            api.addEventListener({
                name:'pause'
            }, function(ret, err){
                app.closeChar();
            });
        }
        else {
            //设置窗口内部事件主页面
            if(api.pageParam._fireWinMain){
                app._fireWinMain=api.pageParam._fireWinMain;
            }
        }
        //本页面 是否是由win直接打开的页面
        app.isAlone= !!(api.pageParam._lastPage&&api.pageParam._lastPage.alone);
        //7.百度统计页面 打开关闭
        //ps:在closeToWin时跳过的页面无法统计关闭时间
        //ps:被重复打开的页面会在关闭第一次时统计关闭
        if(api.pageParam&&api.pageParam._category){
            app.tjPage(api.pageParam._category);
        }
    });
})(window.app || (window.app = {}));