/*
* 用于整理订单状态
*
* */
/*订单状态值*/
var orderStateRule={
    "0":"交易关闭",
    "1":"等待买家付款",
    "2":"等待卖家发货",
    "3":"等待买家确认收货",
    "4":"交易完成",
    "5":"退款中",
    "6":"退款完成",
    "7":"拒绝退款",
    "8":"退货中",
    "9":"等待买家退货",
    "10":"买家已退货",
    "11":"卖家退款中",//(针对卖家)
};
/*订单发货进度*/
var orderStepRule={
    "0":"交易关闭",
    // "1":"等待买家付款",
    "1":"待付款",
    // "2":"等待卖家发货",
    "2":"待发货",
    // "3":"等待买家确认收货",
    "3":"待收货",
    "4":"交易完成"
};
/*
* 整理订单状态值
* orderList:订单数组
* isSeller:是否针对卖家操作
* */
function clearOrderState(orderList,isSeller){
    var stateParam=null,stepParam=null;
    var stateCode,refundCode;
    for(var i=0;i<orderList.length;i++){
        stateCode=orderList[i]["order_state"];//订单状态
        refundCode=orderList[i]["extend_refund_return"];//退款状态
        if(stateCode==0){
            stateParam=0;//"交易关闭"
            stepParam=0;
            if(refundCode){
                if(!!refundCode["refund_id"]){
                    stateParam=clearRefundState(refundCode,isSeller);
                }
            }
        }
        else if(stateCode==10){
            stateParam=1; //"待付款"
            stepParam=1;
        }
        else if(stateCode==20){
            stateParam=2; //"待发货"
            stepParam=2;
            if(refundCode){
                if(!!refundCode["refund_id"]){
                    stateParam=clearRefundState(refundCode,isSeller);
                }
            }
        }
        else if(stateCode==30){
            stateParam=3;  //"待收货";
            stepParam=3;
            if(refundCode){
                if(!!refundCode["refund_id"]){
                    stateParam=clearRefundState(refundCode,isSeller);
                }
            }
        }
        else if(stateCode==40){
            stateParam=4;  //"交易完成";
            stepParam=4;
            if(refundCode){
                if(!!refundCode["refund_id"]){
                    stateParam=clearRefundState(refundCode,isSeller);
                }
            }
        }
        orderList[i].stateInfo={code:stateParam,step:stepParam,des:orderStateRule[stateParam+""],stepDes:orderStepRule[stepParam+""]};
    }
    return orderList;
}

/*
* 区分退款状态
* */
function clearRefundState(refundCode,isSeller){
    var stateParam;
    if(refundCode["refund_type"]==1){
        if(refundCode["refund_state"]==1||refundCode["refund_state"]==2){
            if(isSeller&&refundCode["refund_state"]==2){
                stateParam=11;//卖家退款中（退款中）
            }
            else {
                stateParam=5; //退款中 (待审核)
            }
        }
        else if(refundCode["refund_state"]==3&&refundCode["seller_state"]==2){
            stateParam=6;//退款完成
        }
        else if(refundCode["refund_state"]==4||refundCode["seller_state"]==3){
            stateParam=7;//拒绝退款
        }
    }
    else if(refundCode["refund_type"]==2){
        if(refundCode["refund_state"]==1&&refundCode["seller_state"]==1){
            stateParam=8; //退货中 (待审核)
        }
        else if(refundCode["refund_state"]==1&&refundCode["seller_state"]==2){
            if(refundCode["goods_state"]==1){
                stateParam=9;//等待买家退货 (等待退货)
            }
            else if(refundCode["goods_state"]==2||refundCode["goods_state"]==3||refundCode["goods_state"]==4){
                stateParam=10;//买家已退货 (等待退款)
            }
        }
        else if(refundCode["refund_state"]==2&&refundCode["seller_state"]==2){
            stateParam=5;//退款中
        }
        else if(refundCode["refund_state"]==3&&refundCode["seller_state"]==2){
            stateParam=6;//退款完成
        }
        else if(refundCode["refund_state"]==4||refundCode["seller_state"]==3){
            stateParam=7;//拒绝退款
        }
    }
    return stateParam;
}